import React from 'react';
import PropTypes from 'prop-types';
import styles from './style.css';
import { Toast } from 'antd-mobile';
import UserInfoContext from '../../context/userinfo-context';

export class Index extends React.Component {
  static propTypes = {
    name: PropTypes.string,
  };
  validate = (code, path) => {
    const {
      userinfo: { author },
      history,
    } = this.props;
    let item = author.find(i => i.code === code);
    if (item.type) {
      history.push(path);
      return;
    } else {
      Toast.fail('无权使用该功能');
      return;
    }
  };
  render() {
    return (
      <div className={styles.LoadPage}>
        <h2>HomePage</h2>
        <div onClick={() => this.validate('CSXY0001', '/Repair')}>报修</div>
        <br />
        <div onClick={() => this.validate('CSXY0002', '/RepairDeal')}>
          报修处理
        </div>
        <br />
        <div onClick={() => this.validate('CSXY0003', '/publicCar')}>约车</div>
        <br />
        <div onClick={() => this.validate('CSXY0004', '/publicCarDeal')}>
          约车处理
        </div>
      </div>
    );
  }
}

export default props => (
  <UserInfoContext.Consumer>
    {({ userinfo }) => <Index userinfo={userinfo} {...props} />}
  </UserInfoContext.Consumer>
);
