import React, { Component } from 'react';
import { PullToRefresh, Modal, Toast } from 'antd-mobile';
import styles from './style.css';
import RepairItem from '../Repair/components/RepairItem';
import { fetchReportRepairList, dealRepair } from '../../api/index';
import Perview from '../../components/Perview/Perview';

class RepairDeal extends Component {
  constructor(props) {
    super(props);
    this.state = {
      refreshing: false,
      down: true,
      height: document.documentElement.clientHeight,
      pagination: {
        pageNum: 1,
        pageSize: 50,
      },
      list: [
        {
          address: '该卡北师大ask绝对不阿斯顿快捷巴士的科比爱的快捷巴士的空间',
          applyCellphone: '18108099999',
          applyIdentity: 'string',
          area: 'string',
          areaId: 0,
          createDate: '2018-09-27T03:18:47.973Z',
          dealDate: '2018-09-27T03:18:47.973Z',
          dealState: 1,
          endDate: '2018-09-27T03:18:47.973Z',
          id: 0,
          name: 'string',
          pageNum: 0,
          pageSize: 0,
          repairCellphone: 'string',
          startDate: '2018-09-27T03:18:47.973Z',
          term: 'f阿斯顿 adasdasdasdasdasd',
          termId: 0,
          uploadImg: 'string',
          userId: 0,
        },
        {
          address: 'string',
          applyCellphone: 'string',
          applyIdentity: 'string',
          area: 'string',
          areaId: 0,
          createDate: '2018-09-27T03:18:47.973Z',
          dealDate: '2018-09-27T03:18:47.973Z',
          dealState: 2,
          endDate: '2018-09-27T03:18:47.973Z',
          id: 1,
          name: 'string',
          pageNum: 0,
          pageSize: 0,
          repairCellphone: 'string',
          startDate: '2018-09-27T03:18:47.973Z',
          term: 'string',
          termId: 0,
          uploadImg: '',
          userId: 0,
        },
      ],
    };
  }
  componentDidMount() {
    this.fetchList();
  }
  fetchList = () => {
    const { pagination } = this.state;
    fetchReportRepairList({
      ...pagination,
    }).then(res => {
      // const { list, ...pagination } = res.data;
      // this.setState({
      //   list: list,
      //   pagination: pagination,
      // });
      this.setState({
        list: res.data,
      });
    });
  };
  refreshHandle = () => {
    this.fetchList();
  };
  dealHandle = id => {
    console.log('in date');
    Modal.alert(
      '',
      <div className={styles.alertInfo}>
        <span className={styles.checkLabel}>
          <span className={styles.checkInner} />
        </span>
        <span>已处理</span>
      </div>,
      [
        { text: '放弃', onPress: () => console.log('cancel') },
        {
          text: '提交',
          onPress: () =>
            dealRepair({
              id: id,
            })
              .then(res => {
                Toast.fail(res.msg || '处理成功！');
              })
              .catch(err => {
                Toast.fail(err.msg || '处理失败！');
              }),
        },
      ]
    );
  };
  showViewHandle = (list, index) => {
    this.setState({
      perviewVisibility: true,
      perviewIndex: index,
      selectedImgList: list,
    });
  };
  resetDialog = () => {
    this.setState({
      perviewVisibility: false,
    });
  };
  render() {
    const { perviewVisibility, selectedImgList, perviewIndex } = this.state;
    return [
      <PullToRefresh
        key="repairList"
        damping={60}
        ref={el => (this.ptr = el)}
        style={{
          height: this.state.height,
          overflow: 'auto',
        }}
        indicator={{ deactivate: '上拉可以刷新' }}
        direction={'up'}
        refreshing={this.state.refreshing}
        onRefresh={this.refreshHandle}
      >
        <div className={styles.listInfo}>显示最近半年的报修记录</div>
        {this.state.list.length ? (
          this.state.list.map(i => (
            <RepairItem
              key={i.id}
              data={i}
              dealHandle={this.dealHandle}
              showView={this.showViewHandle}
            />
          ))
        ) : (
          <div className={styles.noData}>暂无数据</div>
        )}
      </PullToRefresh>,
      <Modal
        key="repairImgPerview"
        className={styles.perViewDialog}
        visible={perviewVisibility}
        transparent
        maskClosable={true}
        onClose={this.resetDialog}
        title=""
      >
        <Perview data={selectedImgList} index={perviewIndex} />
      </Modal>,
    ];
  }
}

export default RepairDeal;
